//jcmpanel is the iob of all graphs, maps etc.
//contains basic layout functions

package jcm.gui;
import jcm.*;
import jcm.tls.*;
import jcm.mod.*;
import jcm.pan.*;

import java.awt.*;

public class jcmpanel extends iob implements colfont, modlist {
	//implements modlist so plots can easily refer to modules
	
	
	public bufim bufi=new bufim(this); 
	
	//FLAGS
	public boolean
		hadmouse=false, //had mouse inside? set by mainapp handlevent
		painting=false, //in painting loop
		newpanhelp=false; 
	
	//IOBS
	//simple iobs to track interactions
	public iob pansetup=new iob("pansetup", this); 
	public title titlepop=new title(this); 
	
	//image/tablecapture
	public static param capture=new param("capture", false); static {	capture.owner=new jcmpanel(); }
	public param capim=new param("capim"), captab=new param("captab"); 
	
	//public option captabopt=new option(captab, this), capimopt=new option(capim, this);
	
	//OTHER VARIABLES
	public mainapp holder; //=linker.applet;
	public int panindex=0; //set by linker
	//public String align="right";
	
	public int panx=1, pany=1, panw=1, panh=1; 
	public int cx,cy,cw,ch; //clip (relative to this)
	public int tmh=24; //height of name bar etc.
	
	public double shrinkfactor=1.0; //scales objects
	
	public popob lastob; // see popob.xpos() for usage
	
	//for experiment put all in toppanel
	public static boolean obsintop=false; 
	
	
	//***********************
	//PANEL methods (-some of these not currently used)
	
	public Graphics getGraphics() {	Graphics g=holder.getGraphics().create(panx, pany, panw, panh); g.clipRect(cx,cy,cw,ch); return g; }
	public Graphics getallGraphics() {	Graphics g=holder.getGraphics(); g.translate(panx, pany); return g; }
	public void setclip(int x, int y, int w, int h) {	cx=x; cy=y; cw=w; ch=h; }
	public void noclip() {	cx=0; cy=0; cw=panw; ch=panh; }
	
	public void clear() {	clearRect(0,0,panw,panh); }
	public void clearRect(int x, int y, int w, int h) {	Graphics g=getGraphics(); g.setColor(getBackground()); g.fillRect(x, y, w, h); g.dispose(); }
	
	public void repaint() {	if (output) {	Graphics g=getGraphics(); update(g); g.dispose(); } }
	public void repaint(int x, int y, int w, int h) {	Graphics g=getGraphics(); g.clipRect(x,y,w,h); update(g); g.dispose(); }
	public void repaint(int x) {	try{	wait(x); } catch (InterruptedException e) {	}; repaint(); } //this might not work!
	
	public Dimension size() {	return new Dimension(panw, panh); }
	public Dimension getSize() {	return size(); }
	public Color getBackground() {	return holder.getBackground(); }
	public Image createImage(int x, int y) {	return holder.createImage(x, y); }
	public void update(Graphics g) {	}
	public boolean handleEvent(Event e) {
		if (e.id==Event.MOUSE_DOWN  && holder==iob.applet)  jcm.tls.showwebpage.showhelp(this); 
		return  false; 
	}
	
	public boolean isShowing() {	return output; }
	public boolean inside(int x, int y) {	return (x>panx && x<(panx+panw) && y>pany && y<(pany+panh)); }
	public boolean insiderel(int x, int y) {	return (x>0 && x<panw && y>0 && y<panh); }
	public void move(int x, int y) {	panx=x; pany=y; }
	public void resize(int w, int h) {	panw=w; panh=h; noclip(); shrinkfactor= (panw<500 ? panw/500.0 : 1); pansetup.changed=true; }
	public void resize(int x, int y, int w, int h) {	move(x,y); resize(w,h); }
	public void leave() {	if (!popob.showcontrols.flag) {	changed=true; loop.go(); }}
	public void enter() {	if (!popob.showcontrols.flag) {	changed=true; loop.go(); }}
	
	public void setFont(Font f) {	holder.setFont(f); }
	public String hexcolor(Color c) {
		return " <font color=#"+tdhex(c.getRed())+tdhex(c.getGreen())+tdhex(c.getBlue()) +" > "; 
	}
	public String tdhex(int i) {	String s=Integer.toHexString(i); if (s.length()==1) s="0"+s; return s; } //make two digit as needed by html font
	
	//get x,y in terms of underlying window
	public int rootx (int x) {	return x+panx; }
	public int rooty (int y) {	return y+pany; }
	
	public void makebuffer() {	}
	
	//*******************************
	//ADD/HIDE - for AWT components
	public void add(Component c) {	holder.add(c); }
	public void remove(Component c) {	holder.remove(c); }
	
	//overwrite hide if need to remove AWT components!
	public void hide() {	if (bufi!=null && bufi.im!=null) bufi.im.flush(); }
	public void show() {	}
	
	public boolean alwayscontrols() {	return ( hadmouse || this==holder.cpl.central  || holder!=iob.applet || name.equals("layoutpanel") || name.equals("mitigpanel")); }
	public void setchanged () {	changed=true; output=true; pansetup.changed=true; }
	
	//**********************************************
	//LOOP methods
	
	public void initsetuppanel () {	initsetup((mainapp) iob.applet); }
	public void initsetup (mainapp a) {	holder=a; initsetup(); }
	public void initsetup (mainapp a, Object[] args) {	holder=a; initsetup(); }
	
	public void setinteractions() {
		super.setinteractions(); 
		//only causes redraw of items, not rearrange
		setaffectedby(pansetup); 
		if (menu.oldlistup!=null) setnotaffectedby(menu.oldlistup); 
		if (menu.currentlistup!=null) setaffectedby(menu.currentlistup); 
		/*
		if (capimopt.output) {	setaffectedby(capim); setaffectedby(panlist.toppanel.capim); }
		capimopt.output &= capture.istrue();
		captabopt.output &= capture.istrue();
		*/
		//pansetup calls setup routines too
		pansetup.setaffectedby(complexity.complexity); 
		pansetup.setaffectedby(jcm.tls.labinf.language); 
		if (holder!=null) pansetup.setaffectedby(holder.cpl); //null for dummy iobs for doc
		pansetup.setaffectedby(popob.showcontrols); 
		titlepop.output=output; 
	}
	
	public void setup() {	clearRect(0,0,panw,tmh); } //for methods affected by pansetup iob
	
	public void precalc(iob iob) {
		if (iob==pansetup && output) {	setup(); } //respond to resizing
		if (iob.name=="capim" ) capimage.save(this); 
		if (iob.name=="captab") jcm.tls.fileio.savetextfile("c:/java/jcm/output/"+name+".dat", gettable("\t\t") ); 
	}
	
	//***********************
	
	public void drawString(String s, int x, int y) {	Graphics g=getGraphics(); drawString(g, s, x, y); g.dispose(); }
	public void drawString(Graphics g, String s, int x, int y) {
		int w=g.getFontMetrics(normalfont).stringWidth(s); 
		g.setColor(getBackground()); 
		g.fillRect(x,y,w,16); 
		g.setFont(normalfont); g.setColor(black); 
		g.drawString(s,x,y+14); 
	}
	
	//*****************************
	
	public String docinfo(String what) {
		if (what.equals("menopts"))  return docmenopt(); 
		return super.docinfo(what); 
	}
	
	public String docaffectedby() {	return super.docaffectedby()+" "+bufi.docaffectedby(); }
	
	public String docmenopt() {
		StringBuffer info=new StringBuffer(" `menopts :  <form>"); 
		int n=0; for (int i=0; i<myiobs.size(); i++) {
			if ((myiob(i) instanceof option ||  myiob(i) instanceof menu) && myiob(i).output)  {	info.append(((popob) myiob(i)).param.docinfo(this)); n++; }
		}
		return (n>0) ? info.append("</form>").toString() : ""; 
	}
	
	
} //end jcmpanel
	
	
