//note: WR model ocean mixing parameters now moved to oceantempplot

package jcm.pan;
import jcm.*;
import jcm.mod.*;
import jcm.gui.*; 
import java.awt.Color;

public class glotempplot extends graph {
	
	public menu climod=new menu(heatflux.climod, this); 
	
	public control
		stabtemp=new control(mitigation.stabtempyear, this, "xy", "nsew", brown, 0, 2, "verysimple"),
		climsens=new control(heatflux.climsens, this, "ya", "ns", red, 20, 2, "verysimple"),
		lotr=new control(heatflux.landoceantempratio, this, "ya", "ns", orange, 40, 2, "expert"),
		kns=new control(heatflux.knorthsouth, this, "ya", "ns", dkgreen, 60, 2, "expert"),
		klo=new control(heatflux.klandocean, this, "ya", "ns", yellowgreen, 80, 2, "expert"),
		regcliyear=new control(regcli.year, this, "x", "downarrow", green, 5, 0), //controls the year for the regional climate map
		baseyear=new control(heatflux.baseyear, this, "x", "downarrow", blue, 5, 0); 
	
	public option
		stfuzzy=new option(mitigation.stfuzzy, this, "experimental"),
		damp=new option(mitigation.damp, this, "experimental"); 
	
	public datapoints dp=new datapoints(sres.datayear, new float[][][]{	sres.tempchange}, sres.scenario,  this); 
	
	public void setinteractions() {
		super.setinteractions(); 
		bufi.setaffectedby(heatflux); 
		yscale.max.setaffectedby(heatflux.baseyear); yscale.min.setaffectedby(heatflux.baseyear); 
		boolean st=mitigation.scenario.chosen=="stabtemp"; 
		stfuzzy.output &= st; 
		damp.output &= st && mitigation.stfuzzy.istrue(); 
		stabtemp.output &= st; 
		curveoutput[8] =mitigation.stfuzzy.istrue(); 
		regcliyear.output &=regcli.scale.istrue(); // && panlist.regclimap.output ;
		regcliyear.setaffectedby(regcli.year); regcliyear.setaffectedby(regcli.scale);
	}
	
	public void makecurves() {
		makecurves(
			time.glx,
			new float[][] {	heatflux.avtemp,heatflux.proxytemp,heatflux.tempdata,heatflux.temptrend,heatflux.boxtemp[0],heatflux.boxtemp[1],heatflux.boxtemp[2],heatflux.boxtemp[3], mitigation.otarget},
		new String[] {	"tempav", "tempproxy", "tempdata", "temptrend", "tempnl", "tempno", "tempso", "tempsl",  "target"},
		new Color[] {	brown, greygreen, dkgreen,  green, red, blue, cyan, orange, yellow},
		new String[] {	"verysimple",  "basic",  "basic",  "basic", "expert",  "expert",  "expert",  "expert", "basic" }
		); 
		
		yscale.setup("degcbase", -1.2, 3.2, 0.4, 1.0); 
	}
	
	//float oldoffset=heatflux.avtemp[200]-heatflux.glotemp[200]; //choose 200 as ref to avoid influence from asymptotic stabilisation curves
	
	public void precalc(iob iob) {
		if (iob==baseyear) {
		/*
			float offset=heatflux.avtemp[200]-heatflux.glotemp[200], change=heatflux.offset-heatflux.oldoffset; heatflux.oldoffset=offset; 
			yscale.min.val+=change*yscale.scaleu; 
			yscale.max.val+=change*yscale.scaleu; 
		*/
			dp.offset=new float[]{	heatflux.avtemp[time.hiss-10]}; //note ipcc zero at 1990 hence correction
		}
		super.precalc(iob); 
	}
	
	
		
	} //end class
	
	
	
